import java.awt.Point;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;


public class Security {
	public static class QuadTree {
		private class Node {
			public int x,y;
			public Node UL, UR, BL, BR;
			
			public Node(int x, int y) {
				super();
				this.x = x;
				this.y = y;
			}
			
		}
		
		private Node root = null;
		
		public QuadTree() {
			
		}
		
		
		private void addNode(int x, int y) {
			if(root == null) {
				root = new Node(x, y);
			} else {
				addNode(root, x, y);
			}
			
		}
		
		private void addNode(Node n, int x, int y) {
			if(x < n.x && y < n.y) {
				if(n.UL == null) {
					n.UL = new Node(x, y);
				} else {
					addNode(n, x, y);
				}
			} else if(x >= n.x && y < n.y) {
				if(n.UR == null) {
					n.UR = new Node(x, y);
				} else {
					addNode(n, x, y);
				}
			} else if(x < n.x && y >= n.y) {
				if(n.BL == null) {
					n.BL = new Node(x, y);
				} else {
					addNode(n, x, y);
				}
			} else if(x >= n.x && y >= n.y) {
				if(n.BR == null) {
					n.BR = new Node(x, y);
				} else {
					addNode(n, x, y);
				}
			}
		}
		
		private Point Query(int x, int y) {
			return Query(root, x, y);
		}
		
		private Point Query(Node n, int x, int y) {
			if(x < n.x && y < n.y) {
				System.out.println("A");
				if(n.UL == null) {
					return new Point(n.x, n.y);
				} else {
					return Query(n.UL, x, y);
				}
			} else if(x >= n.x && y <= n.y) {
				System.out.println("B");
				if(n.UR == null) {
					return new Point(n.x, n.y);
				} else {
					return Query(n.UR, x, y);
				}
			} else if(x <= n.x && y > n.y) {
				System.out.println("C");
				if(n.BL == null) {
					return new Point(n.x, n.y);
				} else {
					return Query(n.BL, x, y);
				}
			} else if(x > n.x && y > n.y) {
				System.out.println("D");
				if(n.BR == null) {
					return new Point(n.x, n.y);
				} else {
					return Query(n.BR, x, y);
				}
			} else {
				System.out.println("E");
				return new Point(n.x, n.y);
			}
		}
	}
	

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		String[] tokens;
		
		tokens = br.readLine().split(" ");
		int guardCount = Integer.parseInt(tokens[0]);
		int incidentsCount = Integer.parseInt(tokens[1]);
		
		QuadTree guards = new QuadTree();
		Point[] incidents = new Point[incidentsCount];
		
		for(int i = 0; i < guardCount; i++) {
			tokens = br.readLine().split(" ");
			guards.addNode(Integer.parseInt(tokens[0]), Integer.parseInt(tokens[1]));
		}
		
		for(int i = 0; i < incidentsCount; i++) {
			tokens = br.readLine().split(" ");
			incidents[i] = new Point(Integer.parseInt(tokens[0]), Integer.parseInt(tokens[1]));
		}
		
		for(int i = 0; i < incidentsCount; i++) {
			Point incident = incidents[i];
			Point guard = guards.Query(incident.x, incident.y);
			System.out.println(guard);
			int distance = getDistance(incidents[i], guard);
			System.out.println(distance);
		}
		
	}
	
	public static int getDistance(Point p1, Point p2) {
		int nx = Math.abs(p1.x - p2.x);
		int ny = Math.abs(p1.y - p2.y);
		return (int)Math.floor(Math.sqrt(nx * nx + ny * ny));
	}

}
